article/urls.py
from django.urls import path
from . import views

app_name = 'article'

urlpatterns = [
    # 文章详情
    path('article-detail/<int:id>/', views.article_detail, name='article_detail'),
    # 文章创建
    path('article-create/', views.article_create, name='article_create'),
    # 文章更新
    path('article-update/<int:id>/', views.article_update, name='article_update'),
    # 文章删除
    path('article-delete/<int:id>/', views.article_delete, name='article_delete'),
    # 文章附件下载
    path('article-download/<int:id>', views.download_file, name='download_file'),
]

like/urls.py
from django.urls import path
from . import views

app_name = 'like'

urlpatterns = [
    path('like-change/', views.like_change, name='like_change'),
]

question/urls.py
from django.urls import path
from . import views

app_name = 'question'

urlpatterns = [

    # 文章详情
    path('question-detail/<int:id>/', views.question_detail, name='question_detail'),
    path('question-create/', views.question_create, name='question_create'),
    path('question-update/<int:id>/', views.question_update, name='question_update'),
    path('question-delete/<int:id>/', views.question_delete, name='question_delete'),
    path('question-download/<int:id>', views.download_file, name='download_file'),
]

sailing/urls.py
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import render
from article import views as article_views
from question import views as question_views
from userprofile import views as user_views

from django.conf import settings
from django.conf.urls.static import static
from itertools import chain
import notifications.urls
def mainPage(request):
    return render(request, 'userprofile/collection.html', {})

def sort_column(column_questions, column_articles):
    column_content = []

    for question in column_questions:
        content = {'title': question.title, 'id': question.id, 'column': str(question.column), 'updated': question.updated, 'type': 'question'}
        column_content.append(content)
        pass

    for article in column_articles:
        content = {'title': article.title, 'id': article.id, 'column': str(article.column), 'updated': article.updated, 'type': 'article'}
        column_content.append(content)
        pass

    column_content = sorted(column_content, key=lambda x:(x['column'], x['updated']), reverse = True)
    
    #for item in column_content:
    #    if item['column'] != 'None':
    #        print(item)
    return column_content

def hot_content(request):
    # hotContent
    hot_questions = question_views.hot_question_list(request)
    hot_articles = article_views.hot_article_list(request)
    # blockContent
    column_questions = question_views.column_question_list()
    column_articles = article_views.column_article_list()
    column_content = sort_column(column_questions["column_questions"], column_articles["column_articles"])
    column_content = {'column_content': column_content}

    context = {**hot_questions, **hot_articles, **column_content}
    return render(request, 'mainPage.html', context)

urlpatterns = [
    path('admin/', admin.site.urls),
    path('userprofile/', include('userprofile.urls', namespace='userprofile')),
    path('article/', include('article.urls', namespace='article')),
    path('question/', include('question.urls', namespace='question')),
    path('comment/', include('comment.urls', namespace='comment')),
    path('answer/', include('answer.urls', namespace='answer')),
    path('like/', include('like.urls', namespace='like')),
    path('', hot_content, name='hot_content'),
    path('collect/', include('collect.urls', namespace='collect')),
    path('search_question/', question_views.search_question),
    path('search_article/', article_views.search_article),
    path('search_user/', user_views.search_user),
    path('blocks/',include('blocks.urls', namespace='blocks')),
    path('inbox/notifications/', include(notifications.urls, namespace='notifications')),
    path('notice/', include('notice.urls', namespace='notice')),
    # path('', mainPage)
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

userprofile/urls.py
from django.urls import path
from . import views

app_name = 'userprofile'

urlpatterns = [
    # 用户登入
    path('login/', views.user_login, name='login'),
    # 用户退出
    path('logout/', views.user_logout, name='logout'),
    # 用户退出
    path('register/', views.user_register, name='register'),
    # 用户删除
    path('delete/<int:id>/', views.user_delete, name='delete'),
    # 用户查看信息
    path('profile/<int:id>/', views.profile, name='profile'),
    # 用户编辑信息
    path('profile-update/<int:id>/', views.profile_update, name='profile_update'),
    # 用户修改密码
    path('password-update/<int:id>/', views.password_update, name='password_update'),
    # 用户查看收藏记录
    path('collect-record/<int:id>/', views.get_collect_record, name='get_collect_record'),
    # 用户封禁
    path('user-forbidden/<int:id>/', views.user_forbidden, name='user_forbidden'),
    #查看用户发表的东西
    path('user-get_myob/<int:id>/', views.get_myob, name='user_get_myob'),
]

templates/search/search_article.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load staticfiles %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
    搜索
{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
 <!-- 
片段名称：文章的搜索框
作者:	ssc
时间：	2020-8-1
功能：	在搜索框中输入内容，搜索相应内容
修改记录： 
-->
{% block content %}
    <!-- 新增，对应类型搜索栏 -->
    <div class="container">
        <div class="d-flex justify-content-center mt-4">
            <form class="form-inline" >
                <!-- type对应的是用户在之前的搜索栏选择的类型（问题，文章，回答）-->
                <label for="search" class="mr-4">文章搜索{{type}}</label>
                <input type="text"
                    class="form-control mb-2 mr-sm-2"
                       id="search"
                    name="search"
                    placeholder="搜索文章..."
                    required
                >
            </form>
        </div>
    </div>


<!-- 
片段名称：  搜索结果的显示
作者:	    ssc
时间：	    2020-8-1
功能：	    显示搜索结果，如果搜索到相应结果，会以卡片形式的显示
            显示内容，会显示文章的一部分内容
            并显示文章的结果，显示文章的发布时间
            点击卡片，可以进入文章详情
修改记录： 
-->
    {% if search_a %}
        {% if articles %}
            <h4><span style="color: cadetblue">"{{ search_a }}"</span>的搜索结果如下：</h4>
            <hr>
        {% else %}
            <h4>暂无<span style="color: cadetblue">"{{ search_a }}"</span>有关的{{type}}。</h4>
            <hr>
        {% endif %}
        <div class="container">
            <div class="row mt-2">
    
                {% for article in articles %}
                <!-- 文章内容 -->
                <div class="col-4 mb-4">
                    <!-- 卡片容器 -->
                    <div class="card h-100">
                        <!-- 标题 -->
                        <div class="card-header">
                        <span>{{ article.title }}</span>
                        {% if article.column %}
                        <a href=
                        {% if article.column.title == '生活' %}
                            "/blocks/blocks-list-life/"
                        {% elif article.column.title == '学习' %}
                            "/blocks/blocks-list-study/"
                        {% elif article.column.title == '交友' %}
                            "/blocks/blocks-list-friend/"
                        {% endif %}>
                        <button type="button"
                         class="btn btn-sm mb-2
                        {% if article.column.title == '生活' %}
                            btn-warning
                        {% elif article.column.title == '学习' %}
                            btn-danger
                        {% elif article.column.title == '交友' %}
                            btn-success
                        {% endif %} "
                        style=" float:right">
                        {{ article.column }}
                        </button>
                        </a>
                        {% endif %}
                        </div>
                        <!-- 摘要 -->
                        <div class="card-body">
                            <p class="card-text">{{ article.body|slice:'100' }}...</p>
                        </div>
                        <!-- 注脚 -->
                        <div class="card-footer">
                            <span>
                                <i class="fas fa-user" style="color:yellowgreen"></i>
                                {{ article.author }}
                            </span>
                            <span>
                                <i class="fas fa-clock" style="color:gray;"></i>
                                {{ article.created|date:'Y-m-d' }}
                            </span>
                            <span>
                                <i class="fas fa-clock" style="color:pink;"></i>
                                {{ article.updated|date:'Y-m-d' }}
                            </span>
                            <a  href="{% url 'article:article_detail' article.id %}" class="btn btn-primary">阅读本文</a>
                        </div>
                    </div>
                </div>
            {% endfor %}
    
            </div>
        </div>
    {% else %}
    <div class="container">


    <div class="row mt-2">

        {% for article in articles %}


        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if article.column %}
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if article.column.title == '生活' %}
                            btn-warning
                        {% elif article.column.title == '学习' %}
                            btn-danger
                        {% elif article.column.title == '交友' %}
                            btn-success
                        {% endif %}
                    "
                >
                    {{ article.column }}
                </button>
            {% endif %}

            <!-- 标题 -->
            <h4>
                <b>
                    <a href="{% url 'article:article_detail' article.id %}"
                       style="color: black;"
                    >
                        {{ article.title }}
                    </a>
                </b>
            </h4>
            <!-- 摘要 -->
            <div>
                <p style="color: gray;">
                    {{ article.body|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息，增加了图标 -->
                <span>
                    <i class="fas fa-eye" style="color: lightskyblue;"></i>
                    {{ article.total_views }}&nbsp;&nbsp;&nbsp;
                </span>
                <span>
                    <i class="fas fa-comments" style="color: yellowgreen;"></i>
                    <!-- 修改为评论的计数 -->
                    {{ article.comments.count }}&nbsp;&nbsp;&nbsp;
                </span>
                <span>
                    <i class="fas fa-clock" style="color: pink;"></i>
                    {{ article.created|date:'Y-m-d' }}
                </span>
            </p>
            <hr>
        </div>
        <hr style="width: 100%;"/>
    {% endfor %}

<!-- 
片段名称：  页码导航部分
作者:	    wzd
时间：	    2020-8-1
功能：	    如果搜索结果有多页，实现在不同页面之间的跳转
修改记录： 
--> 
    </div>
    <!-- 页码导航 -->
    <div class="pagination row">
        <div class="m-auto">
            <span class="step-links">
                <!-- 如果不是第一页，则显示上翻按钮 -->
                {% if articles.has_previous %}
                    <a href="?page=1&order={{ order }}&search={{ search }}&column={{ column }}" class="btn btn-success">
                        &laquo; 1
                    </a>
                    <span>...</span>
                    <a href="?page={{ articles.previous_page_number }}&order={{ order }}&search={{ search }}&column={{ column }}" class="btn btn-secondary">
                        {{ articles.previous_page_number }}
                    </a>
                {% endif %}

                <!-- 当前页面 -->
                <span class="current btn btn-danger btn-lg">
                    {{ articles.number }}
                </span>

                <!-- 如果不是最末页，则显示下翻按钮 -->
                {% if articles.has_next %}
                    <a href="?page={{ articles.next_page_number }}&order={{ order }}&search={{ search }}&column={{ column }}&tag={{ tag }}" class="btn btn-secondary">
                        {{ articles.next_page_number }}
                    </a>
                    <span>...</span>
                    <a href="?page={{ articles.paginator.num_pages }}&order={{ order }}&search={{ search }}&column={{ column }}&tag={{ tag }}"class="btn btn-success">
                        {{ articles.paginator.num_pages }} &raquo;
                    </a>
                {% endif %}
            </span>
        </div>
    </div>

</div>
    {% endif %}

  
{% endblock content %}

templates/search/search_question.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load staticfiles %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
    搜索
{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}
<!-- 写入 base.html 中定义的 content -->
 <!-- 
片段名称：问题的搜索框
作者:	ssc
时间：	2020-8-1
功能：	在搜索框中输入内容，搜索相应内容
修改记录： 
-->
    <!-- 新增，对应类型搜索栏 -->
    <div class="container">
        <div class="d-flex justify-content-center mt-4">
            <form class="form-inline" >
                <!-- type对应的是用户在之前的搜索栏选择的类型（问题，文章，回答）-->
                <label for="search" class="mr-4">问题搜索{{type}}</label>
                <input type="text"
                    class="form-control mb-2 mr-sm-2"
                       id="search"
                    name="search"
                    placeholder="搜索问题..."
                    required
                >
            </form>
        </div>
    </div>

 <!-- 
片段名称：  搜索结果的显示
作者:	    ssc
时间：	    2020-8-1
功能：	    显示搜索结果，如果搜索到相应结果，会以卡片形式的显示
            显示内容，会显示文章的一部分内容
            并显示文章的结果，显示文章的发布时间
            点击卡片，可以进入文章详情
修改记录： 
-->
    {% if search_q %}
        {% if questions %}
            <h4><span style="color: cadetblue">"{{ search_q }}"</span>的搜索结果如下：</h4>
            <hr>
        {% else %}
            <h4>暂无<span style="color: cadetblue">"{{ search_q }}"</span>有关的{{type}}。</h4>
            <hr>
        {% endif %}
        <div class="container">
            <div class="row mt-2">
    
                {% for question in questions %}
                <!-- 文章内容 -->
                <div class="col-4 mb-4">
                    <!-- 卡片容器 -->
                    <div class="card h-100">
                        <!-- 标题 -->
                        <div class="card-header">
                        <span>{{ question.title  }}</span>
                        {% if question.column %}
                        <a href=
                        {% if question.column.title == '生活' %}
                            "/blocks/blocks-list-life/"
                        {% elif question.column.title == '学习' %}
                            "/blocks/blocks-list-study/"
                        {% elif question.column.title == '交友' %}
                            "/blocks/blocks-list-friend/"
                        {% endif %}>
                        <button type="button"
                         class="btn btn-sm mb-2
                        {% if question.column.title == '生活' %}
                            btn-warning
                        {% elif question.column.title == '学习' %}
                            btn-danger
                        {% elif question.column.title == '交友' %}
                            btn-success
                        {% endif %}" 
                        style=" float:right">
                        {{question.column }}
                        </button>
                        </a>
                        {% endif %}
                        </div>
                        <!-- 摘要 -->
                        <div class="card-body">
                            <p class="card-text">{{ question.description|slice:'100' }}...</p>
                        </div>
                        <!-- 注脚 -->
                        <div class="card-footer">
                            <span>
                                <i class="fas fa-user" style="color:yellowgreen"></i>
                                {{ question.author }}
                            </span>
                            <span>
                                <i class="fas fa-clock" style="color:gray;"></i>
                                {{ question.created|date:'Y-m-d' }}
                            </span>
                            <span>
                                <i class="fas fa-clock" style="color:pink;"></i>
                                {{ question.updated|date:'Y-m-d' }}
                            </span>
                            <a  href="{% url 'question:question_detail' question.id %}" class="btn btn-primary">阅读本文</a>
                        </div>
                    </div>
                </div>
            {% endfor %}
    
            </div>
        </div>
    {% else %}
       <!-- 定义放置文章标题的div容器 -->
<div class="container">


    <div class="row mt-2">

        {% for question in questions %}


        <!-- 文章内容 -->
        <div class="col-12">
            <!-- 栏目 -->
            {% if question.column %}
                <button type="button"
                    class="btn btn-sm mb-2
                        {% if question.column.title == '生活' %}
                            btn-warning
                        {% elif question.column.title == '学习' %}
                            btn-danger
                        {% elif question.column.title == '交友' %}
                            btn-success
                        {% endif %}
                    "
                >
                    {{ question.column }}
                </button>
            {% endif %}


            <!-- 标题 -->
            <h4>
                <b>
                    <a href="{% url 'question:question_detail' question.id %}"
                       style="color: black;"
                    >
                        {{ question.title }}
                    </a>
                </b>
            </h4>
            <!-- 摘要 -->
            <div>
                <p style="color: gray;">
                    {{ question.description|slice:'100' }}...
                </p>
            </div>
            <!-- 注脚 -->
            <p>
                <!-- 附加信息，增加了图标 -->
                <span>
                    <i class="fas fa-eye" style="color: lightskyblue;"></i>
                    {{ question.total_views }}&nbsp;&nbsp;&nbsp;
                </span>
                <span>
                    <i class="fas fa-comments" style="color: yellowgreen;"></i>
                    <!-- 修改为评论的计数 -->
                    {{ question.answers.count }}&nbsp;&nbsp;&nbsp;
                </span>
                <span>
                    <i class="fas fa-clock" style="color: pink;"></i>
                    {{ question.created|date:'Y-m-d' }}
                </span>
            </p>
            <hr>
        </div>
        <hr style="width: 100%;"/>
    {% endfor %}

    </div>
<!-- 
片段名称：  页码导航部分
作者:	    wzd
时间：	    2020-8-1
功能：	    如果搜索结果有多页，实现在不同页面之间的跳转
修改记录： 
--> 
    <div class="pagination row">
        <div class="m-auto">
            <span class="step-links">
                <!-- 如果不是第一页，则显示上翻按钮 -->
                {% if questions.has_previous %}
                    <a href="?page=1&order={{ order }}&search={{ search }}&column={{ column }}" class="btn btn-success">
                        &laquo; 1
                    </a>
                    <span>...</span>
                    <a href="?page={{ questions.previous_page_number }}&order={{ order }}&search={{ search }}&column={{ column }}" class="btn btn-secondary">
                        {{ questions.previous_page_number }}
                    </a>
                {% endif %}

                <!-- 当前页面 -->
                <span class="current btn btn-danger btn-lg">
                    {{ questions.number }}
                </span>

                <!-- 如果不是最末页，则显示下翻按钮 -->
                {% if questions.has_next %}
                    <a href="?page={{ questions.next_page_number }}&order={{ order }}&search={{ search }}&column={{ column }}&tag={{ tag }}" class="btn btn-secondary">
                        {{ questions.next_page_number }}
                    </a>
                    <span>...</span>
                    <a href="?page={{ questions.paginator.num_pages }}&order={{ order }}&search={{ search }}&column={{ column }}&tag={{ tag }}"class="btn btn-success">
                        {{ questions.paginator.num_pages }} &raquo;
                    </a>
                {% endif %}
            </span>
        </div>
    </div>

</div>
    {% endif %}

  
{% endblock content %}

templates/search/search_user.html
<!-- extends表明此页面继承自 base.html 文件 -->
{% extends "base.html" %}
{% load staticfiles %}

<!-- 写入 base.html 中定义的 title -->
{% block title %}
    用户搜索
{% endblock title %}

<!-- 写入 base.html 中定义的 content -->
{% block content %}
 <!-- 
片段名称：用户的搜索框
作者:	ssc
时间：	2020-8-1
功能：	在搜索框中输入内容，搜索相应内容
修改记录： 
-->
    <!-- 新增，对应类型搜索栏 -->
    <div class="container">
        <div class="d-flex justify-content-center mt-4">
            <form class="form-inline" >
                <!-- type对应的是用户在之前的搜索栏选择的类型（问题，文章，回答）-->
                <label for="search" class="mr-4">用户搜索</label>
                <input type="text"
                    class="form-control mb-2 mr-sm-2"
                       id="search"
                    name="search"
                    placeholder="搜索用户..."
                    required
                >
            </form>
        </div>
    </div>

<!-- 
片段名称：  搜索结果的显示
作者:	    ssc
时间：	    2020-8-1
功能：	    显示搜索结果，如果搜索到相应结果，会以列表形式的显示
            搜索到的用户，可以通过链接进入个人空间
            如果是拥有超级权限的话，可以禁封用户
修改记录： 
-->
    <!-- 新增，搜索提示语 -->
    {% if search_u %}
        {% if users %}
            <h4><span style="color: cadetblue">"{{ search_u }}"</span>的搜索结果如下：</h4>
            <hr>
        {% else %}
            <h4>暂无<span style="color: cadetblue">"{{ search_u }}"</span>有关的用户。</h4>
            <hr>
        {% endif %}
        <div class="row mt-2 ml-4">
            <ul class="list-group">

                {% for user in users %}
                    <li class="list-group-item">
                        <a href="{% url 'userprofile:user_get_myob' user.id %}"><!--链接到用户信息界面-->
                        用户名：
                        <span style="color: #5897fb;">
                            {{ user.username }}
                        </span>
                        邮箱：
                         <span style="color: #01a252;">{{ user.email }}</span>
                        </a>

                        {% if request.user.is_superuser %}
<!--         <a  href="{% url 'userprofile:user_forbidden' user.id %}" class="btn btn-primary">封禁用户</a>-->


                        <a href="#" onclick="confirm_fib_user()" class="btn btn-primary">封禁用户</a>
<script>
// 函数名称：禁封函数
//作者：    tyt
//时间：    2020-08-01
//函数功能： 弹窗提示是否禁封用户
//          如果确认禁封
    function confirm_fib_user() {
        // 调用layer弹窗组件
        layer.open({
            // 弹窗标题
            title: "确认禁封",
            // 正文
            content: "确认禁封该用户吗？",
            // 点击确定按钮后调用的回调函数
            yes: function(index, layero) {
                // 指定应当前往的 url
                location.href="{% url 'userprofile:user_forbidden' user.id %}"
            },
        });
    }
</script>
                        {% endif %}
                    </li>
                {% endfor %}

            </ul>
        </div>
    {% else %}
    <h4>暂无搜索内容</h4>
    {% endif %}

 {% if messages %}
<!--弹框形式-->
        <script>
            {% for msg in messages %}
                alert('{{ msg.message }}');
            {% endfor %}
        </script>
{% endif %}
{% endblock content %}

{% block script %}

{% endblock script %}